/********************************************************************************************
 * Projekt:		FRITZ!Box AddOn																*
 * Version:		2.00.04																		*
 * Plattform:	XP/Vista/Windows 7/Windows 8 sowie MacOS/Linux (ohne XP-COM)				*
 *																							*
 * Modul:		Java-Script fr About-Fenster des Firefox Addon								*
 * Autor:		Karsten																		*
 * Dateiname:	About.js																	*
 *																							*
 * 02.09.2014	bessere Prfung ob Repeater gefunden										*
 * 25.05.2011	laden bei onload, falls nicht Daten nicht da								*
 * 05.05.2011	Ticks verlngern und zurcksetzen											*
 * 10.08.2010	C-Types Schnittstelle														*
 * 19.01.2010	Zeichenketten als Resourcen													*
 * 22.10.2009	bessere Untersttzung fr "ohne XP-COM"										*
********************************************************************************************/
var FB_AddonAbout = new FB_AddonPrototyp();
var tick = 0;
var MAX_TICKS = 20;//halbe Sekunde

function FB_AddonAbout_onload() {
	FB_AddonAbout.szInstance = "About";
	//FB_AddonAbout.m_bDebug = true;
	FB_AddonAbout.ResourceBundle = document.getElementById("fb_add_on-strings");
	//alert( "LoadData()" );
	var s = "FRITZ!Box gefunden";

	//alert( FB_Addon.getString("About") );

	try {	//Aufruf aus Script
		s = window.arguments[0].inn.about;
	}
	catch (err) {	//Aufruf aus Addon Dialog des FF
		FB_AddonAbout.init();
		if (FB_AddonAbout.xpCom != null) {
			s = FB_AddonAbout.xpCom.GetString("AboutText");
		}
	}

	if( (s.indexOf("Firmware") != -1) || (s.indexOf("firmware") != -1) ) {
		document.getElementById("aboutHardware").value = s;
	}
	else {
		FB_AddonAbout_onReload();
	}
}

function FB_AddonAbout_onTimeout() {
	var s = FB_AddonAbout.ResourceBundle.getString("AboutTimeout");
	var enable = false;

	if (FB_AddonAbout.xpCom) {
		var sAbout = FB_AddonAbout.xpCom.GetString("AboutText");
		//Repeater
		var result = -1;
		var modus = FB_AddonAbout.get("Repeater");

		if( modus > 0 ) {
			var product = FB_AddonAbout.getString("ProduktName");
			result = product.length + 10;
		}
		
		if( (sAbout.lastIndexOf("Firmware") > result) || (sAbout.lastIndexOf("firmware") > result) ) {
			s = sAbout;
			enable = true;
		}
		else {
			tick = tick + 1;
			if (MAX_TICKS > tick) {
				s = document.getElementById("aboutHardware").value + ".";
				setTimeout("FB_AddonAbout_onTimeout()", 500);
			}
			else {
				enable = true;
			}
		}
	}
	//ohne XP-COM
	else
	{
		var sTemp = FB_AddonAbout.getAboutText();

		if( sTemp.length > 0 )
		{
			s = sTemp;
			enable = true;
		}
		else
		{
			tick = tick + 1;
			if (MAX_TICKS > tick) {
				s = document.getElementById("aboutHardware").value + ".";
				setTimeout("FB_AddonAbout_onTimeout()", 500);
			}
			else {
				enable = true;
			}
		}
	}

	document.getElementById("aboutHardware").value = s;
	
	if( enable ) {
		document.getElementById("reloader").disabled = false;
	}
}

function FB_AddonAbout_onReload() {
	document.getElementById("aboutHardware").value = FB_AddonAbout.ResourceBundle.getString("AboutWaitReload");
	document.getElementById("reloader").disabled = true;
	//Refresh
	setTimeout("FB_AddonAbout_doReload()", 100);
}

function FB_AddonAbout_doReload() {
	tick = 0;//Wartezeit aus
	FB_AddonAbout.init();
	
	if (FB_AddonAbout.xpCom) {
		FB_AddonAbout.xpCom.Detect(-1);
		//alert("ReloadInfos() Start");
		//FB_AddonAbout.xpCom.DoAction(2, 0, "");//Dial
		//s = FB_AddonAbout.xpCom.AboutText;
	}
	else
	{
		FB_AddonAbout.loadBoxInfo();
		FB_AddonAbout.loadBoxInfoRepeater();
	}
	//nicht warten
	setTimeout("FB_AddonAbout_onTimeout()", 100);
}