/********************************************************************************************
* Projekt:		FRITZ!Box AddOn																*
* Version:		2.00.04																		*
* Plattform:	XP/Vista/Windows 7, Windows 8.1 sowie MacOS/Linux (ohne XP-COM)				*
*																							*
* Modul:		Java-Script fr Firefox Addon												*
* Autor:		Karsten																		*
* Dateiname:	FB_AddOn_Main.js															*
*																							*
* 20.06.2014	Neue Webseitenstruktur														*
* 10.12.2013	Neue Struktur ohne config.dev												*
* 31.10.2012	Benutzername fr Signle Sign On												*
* 02.09.2011	Repeater (auch N/G) mit Javscriptupdate										*
* 10.08.2010	C-Types Schnittstelle														*
* 28.06.2010	Jason-Update des Addon und der Firmware per HttpRequest und Bugfixes Linux	*
* 03.06.2010	"+" wird zu "00" bei Nicht-Nationalen Rufnummern							*
* 25.11.2009	Externe IP mittels XMLHttpRequest											*
* 17.11.2009	Whlhilfe auch mittel Script												*
* 08.10.2009	Config.def laden und Werte parsen, die ohne XP-COM verwendet werden knnen.	*
* 02.07.2009	Umstellung auf Prototyp und this Code										*
* 10.06.2009	Laufwerke suchen und Laufwerke-Men erweitern								*
* 28.05.2009	Fallback/Workaround: ffnen des Ftp-Home falls XP-COM nicht existiert		*
* 22.04.2009	Speicher und Aktualisieren sowie Umstellung auf namespace					*
********************************************************************************************/

function FB_AddonPrototyp() { }
//Prototyp des Addon Objektes
FB_AddonPrototyp.prototype = 
{
	classID 				: null,
	contractID				: "@www.avm.de/FB_AddOn;1",	 
	classCID				: "19542FF-2CD4-4AFD-A9DC-9E9647F30792",
	CID_FB_ADDON	  		: "@www.avm.de/FB_AddOn;1",
	xpCom					: null,
	gPrefs					: null,
	bReadRegistry			: false,//nur einmal Lesen
	bLaufwerkeSuchen		: true,
	//m_bDebug				: true, // Debugmeldungen an
	m_bDebug				: false, // Debugmeldungen aus
	bTelNoMarkieren			: false,
	bIpStatusBar			: true,//IP-Adresse im Statusbar zeigen
	updateMode				: true,//automatisch
	htmlConfigDef			: "",
	htmlConfigDefRepeater	: "",
	xmlReqBoxInfo			: null,
	szBenutzerName			: "",
	szKennwort				: "",//im Script-Modus
	szNationalVorwahl		: "+49",
	szAmtVorwahl			: "0",
	szVorwahlInternational	: "00",
	szAvmHomepage			: "www.avm.de",
	szExternalIp			: "",
	szFritzBoxUrl			: "http://fritz.box/",
	szFritzBoxUrlDefault	: "http://fritz.box/",
	szFritzRepeaterUrl		: "",//leer sonst werden Daten geladen
	szFtpHome				: "ftp://fritz.box/",
	szInstance				: "Standard",//Debuggen
	szServicePortal			: "http://avm.de/service/",
	szOnlineHilfe			: "http://avm.de/service/",
	szUpdate				: "http://avm.de/service/",
	szFBoxDSLInfo   		: "C:\\Program Files\\FRITZ!Box\\AddOn (IE)\\FBoxDSLInfo.html",
	szAbout		  			: "Es konnten keine Details zur FRITZ!Box ermittelt werden.",
	szLaufwerk  			: new Array("\\\\fritz.box","","","",""),
	szLaufwerkText 			: new Array("","","","",""),
	ResourceBundle			: null,
	ExternalIp				: "",
	xmlRequest				: "",
	xmlRequestBox			: "",
	xmlBoxInfo				: "",
	xmlBoxInfoRepeater		: "",
	//SOAP-Update im Script
	NONCE					: "",
	NONCE_BOX				: "",
	NONCE_REPEATER			: "",
	UPDATE_SERVER			: "http://jws.avm.de/Jason/UpdateCheck",
	Guid					: "",
	OperatingSystem			: navigator.userAgent,
	szVersion				: "",
	updateModus				: 0,

	initAddon : function() {
		//alert("initAddon");
		with (this) {
			init();

			onLaufwerkeSuchen();
			aktualisiereMenu();
			//alertDebug( "init() beendet");
		}
	},
	//Initialisierung von fb_add_on
	init : function() {
		//alert("init fb_addon");
		with (this) {
			classID = Components.ID("78f95bf7-c02f-4c74-beae-87d818ac466f");//C-Header
			ResourceBundle = document.getElementById("fb_add_on-strings");
			//lokalisierte Werte einlesen
			if (ResourceBundle != null) {
				szAvmHomepage = ResourceBundle.getString("AVM_Homepage");
				szUpdate = ResourceBundle.getString("AVM_Update");
				szServicePortal = ResourceBundle.getString("AVM_ServicePortal");
			}
			else { alertDebug("Kein Resourcebundle"); }
			
			var bUseCTypes = true;//Debug ohne dll
			
			if (gPrefs == null) {
				var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				gPrefs = prefs.getBranch("extensions.FB_AddOn.");
				gPrefs.clearUserPref("Kennwort");
			}
			
			if (xpCom == null) {
				try {
					if( bUseCTypes )
					{
						alertDebug( "XP-COM wird durch C-Types ersetzt");
						xpCom = new ADDON_DLLPrototyp();
						xpCom.m_bDebug = this.m_bDebug;
						bUseCTypes = xpCom.init();
					}
					
					if( !bUseCTypes )
					{
						alertDebug("XP-COM Fallback init()");
						if(!(CID_FB_ADDON in Components.classes))
						{
							alertDebug("XP-COM Klasse fehlt" + CID_FB_ADDON);
						}
						
						var compClass = Components.classes[CID_FB_ADDON];

						if (compClass) {
							var instance = compClass.createInstance();

							if (instance) {
								xpCom = instance.QueryInterface(Components.interfaces.IFB_AddOn);
								alertDebug("XP-COM init()");
							}
							else {
								alertDebug("No CID_FB_ADDON instance");
							}
						}
						else {
							alertDebug("No CID_FB_ADDON compClass");
						}
					}
				}
				catch (err) {
					alertDebug("XP-COM laden " + err);
				}
			}

			var iDetect = 1;
			var lang = ResourceBundle.getString("Sprache");

			if (lang == "enu") {
				iDetect = 11;
			}
			
			if( (xpCom != null) && (xpCom.Detect != null) ) { //Linux
				var rc = xpCom.Detect(iDetect);
				getWerte();
			}
			else {
				alertDebug( szInstance + ": xpCOM wird auf Null gesetzt, da Schnittstelle nicht funktioniert");
				xpCom = null;
			}			

			loadBoxInfo();

			if( xpCom == null ) {
				alertDebug("No XP-COM/ADDON");
				bReadRegistry = false;
				getWerte();
				loadBoxInfoRepeater();
				loadConfigDef();
				loadConfigDefRepeater();
				var date = new Date();
				var jetzt = date.getTime() / 3600 / 1000;//in ms -> berlauf
				var last = get("UpdateTime");
				if( last < 0 ) last = 0;//First time
				//alert("Jetzt: " + jetzt + "\nLast: " + last );
				
				if( (jetzt-last) > (7*24) ) {
					updateModus = get("Update");
					set( "UpdateTime", jetzt );
					DoAddonUpdate(updateModus);
				}
			}
		} //this
		//krnender Abschluss: Ip-aktualisierung
		setTimeout("FB_Addon_Update_Statusbar()", 10 * 1000);
	},
	
	getWerte : function() {
		try {
			with (this) {
				if (bReadRegistry == false) {
					bReadRegistry = true;

					if( xpCom != null ) {
						xpCom.DoAction(-1,0,"reinit");

						ladeRegistry();
						//alert(szInstance + "getWerte() aus XP-COM " + bTelNoMarkieren);
					}
					else {  
						alertDebug(szInstance + "getWerte() Prefs (kein XP-COM)");
						if (gPrefs == null) {
							var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
							gPrefs = prefs.getBranch("extensions.FB_AddOn.");
						}
					//Werte einlesen
						bTelNoMarkieren = get("TelNoMarkieren");
						bIpStatusBar = get("IpStatusBar");
						szNationalVorwahl = getString("NationalVorwahl");
						Guid = getString("GUID");
						szBenutzerName = getString("Benutzername");
						szFritzRepeaterUrl = getString("FritzRepeaterIp");
						loadBoxInfoRepeater();//fr SID
						var s = getString("FritzBoxIp");
						if( s.length == 0 ) s = getString("FritzBoxUrl");//Fallback
						if( s.length > 0 ) szFritzBoxUrl = s;
						
						if( szFritzBoxUrl.indexOf("http://") < 0 ) {
							szFritzBoxUrl = "http://" + szFritzBoxUrl;
						}
					}
				}
			}
		} catch (err) { this.alertDebug(err); }
	},
	
	//zuerst wird XP-COM Passswort ermittelt, falls kein XP-COM dann wird der FF Login Manager bemht
	getPasswort : function() {
		var password = '';

		if (this.xpCom != null) {
			if (this.xpCom.GetValue != null) {
				password = this.xpCom.GetValue(2, 4);

				return password;
			}
		}

		var hostname = 'http://fritz.box';
		var formSubmitURL = hostname;
		var httprealm = null;
		var username = ''; //

		try {
			// Get Login Manager 
			var loginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);

			// Find users for the given parameters
			var logins = loginManager.findLogins({}, hostname, formSubmitURL, httprealm);

			// Find user from returned array of nsILoginInfo objects
			for (var i = 0; i < logins.length; i++) {
				//alert(logins[i].password);
				if (logins[i].username == username) {
					this.szKennwort = logins[i].password;
					return this.szKennwort;
				}
			}
		}
		catch (e) { this.alertDebug(e); }

		return "";
	},

	//zuerst wird XP-COM Passwort ermittelt, falls kein XP-COM dann wird der FF Login Manager bemht
	setPasswort : function(passwort) {
		if (passwort.length <= 0) {
			passwort = "";
		}

		if (this.xpCom != null) {
			this.xpCom.SetString("Kennwort", passwort);
		}
		else {
			this.szKennwort = passwort;
		}
		//Login Manager crasht mit leeren Passwort
		if(passwort.length == 0) return;

		var hostname = 'http://fritz.box';
		var formSubmitURL = hostname;
		var httprealm = null;
		var username = '';

		try {
			// Get Login Manager 
			var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
			var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");

			// Find users for this extension 
			var logins = myLoginManager.findLogins({}, hostname, formSubmitURL, httprealm);
			//bestehende Logins lschen 
			for (var i = 0; i < logins.length; i++) {
					if (logins[i].username == username) {
						myLoginManager.removeLogin(logins[i]);
					break;
				}
			}

			var extLoginInfo = new nsLoginInfo(hostname, formSubmitURL, httprealm, "", passwort, "", "");
			//neu hinzufgen
			myLoginManager.addLogin(extLoginInfo);
		}
		catch (e) { alert(e); }
	},
	
	getSelection : function() {
		var FFWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');
		var szSelection = FFWindow.getSelection().toString();

		return szSelection;
	},

	getSelectionTelNo : function() {
		with (this) {
			var selText = getSelection();
			//alert(selText);
			var nr = getTelNoClean(selText);
			nr = getTelNoNationalVorwahl(nr);
		}
		return nr;
	},
	//FRITZ!Box Startseite aufrufen.
	getFritzBoxHome : function() {
		with (this) {
			if (xpCom) {
				var s = xpCom.GetString("FritzBoxIp");

				if (s.length > 0) {
					szFritzBoxUrl = s;
				}
			}
			else if (gPrefs != null ) {
				if (gPrefs.prefHasUserValue("FritzBoxIp")) {
					szFritzBoxUrl = gPrefs.getCharPref("FritzBoxIp");
				}
				else if (gPrefs.prefHasUserValue("FritzBoxUrl")) {//Fallback
					szFritzBoxUrl = gPrefs.getCharPref("FritzBoxUrl");
				}
			}

			if (szFritzBoxUrl.length == 0) {
				szFritzBoxUrl = szFritzBoxUrlDefault;
			}

			return szFritzBoxUrl;
		}
	},
	
	onWebGui: function () {
	   var home = this.getFritzBoxHome();
		var kennwort = this.getPasswort();

		if( (kennwort.length > 0) && (this.getFritzOS() >= "05.50") ) {
			var benutzerName = this.getString("Benutzername");
			var sid = fb_add_on_sid(home, benutzerName, kennwort);
		   home = home + "/home/home.lua?sid=" + sid;
		}
		this.openTab(home);
	},
	
	//FRITZ!Repeater Startseite aufrufen.
	onWebGuiRepeater : function() {
		with (this) {
			if (xpCom) {
				szFritzRepeaterUrl = xpCom.GetString("FritzRepeaterIp");
			}
			else if (gPrefs != null ) {
				if (gPrefs.prefHasUserValue("FritzRepeaterIp")) {
					szFritzRepeaterUrl = gPrefs.getCharPref("FritzRepeaterIp");
				}
			}

			if (szFritzRepeaterUrl.length == 0) {
				szFritzRepeaterUrl = "fritz.repeater";
			}

			loadBoxInfoRepeater();
			alertDebug("Aufruf von der Repeater = " + szFritzRepeaterUrl);

			var home = szFritzRepeaterUrl;
			var version = getVersionInstalledRepeater();

          //NLR hat keine Boxinfo und kann das nicht
			if( (version.length > 0) && (version.indexOf("68") != 0) ) {
			    var kennwort = getPasswort();
			    var sid = fb_add_on_sid(home, "", kennwort);
			    
			    if (sid.length > 6) {
			        home = home + "/home/home.lua?sid=" + sid;
			    }
			}
			openTab(home);
		}
	},
	
	onWebGuiPowerline: function() {
		var url = "http://fritz.powerline";
		this.openTab(url);
	},
	
	onWebGuiSmartHome: function() {
	   var home = this.getFritzBoxHome();
	   var url = home + "/net/home_auto_overview.lua";
		var kennwort = this.getPasswort();
		
		if( (kennwort.length > 0)&& (this.getFritzOS() >= "05.50") ) {
			var benutzerName = this.getString("Benutzername");
			var sid = fb_add_on_sid(home,benutzerName, kennwort);
			url = url + "?sid=" + sid;
		}

		this.openTab(url);
	},
	//AVM Homepage aufrufen.
	onHomepage : function() {
		this.openTab(this.szAvmHomepage);
	},
	//
	onOnlineHilfe : function() {
		with (this) {
			if (xpCom) {
				var s = xpCom.OnlineHilfe;

				if (s.length > 0) {
					szOnlineHilfe = s;
				}
			}

			openTab(szOnlineHilfe);
		}
	},

	onServicePortal : function() {
		var s = "";
		var boxname = "";
		this.getFritzOS();
		
		if (this.xpCom) {
			s = this.xpCom.GetString("ServicePortal");
			boxname = this.xpCom.GetString("ProduktName");
		}
		else {
			s = this.getConfigDefValue(this.htmlConfigDef,"ServiceportalUrl");
			boxname = this.getBoxInfo("Name");
		}
		
		//nur fr deutsch
		if( (s.length == 0) && (boxname.length > 3) && (this.szServicePortal.indexOf("/de/") > 0) ) {
			var numbers = boxname.match(/[0-9]+/g).toString();
			if( numbers.length == 4 ) {
				//s = "http://www.avm.de/de/Service/Service-Portale/Service-Portal/index.php?portal=FRITZ!Box_" + numbers;
				s = "http://avm.de/service/fritzbox/fritzbox-" + numbers + "/uebersicht/";
			}
		}

		if (s.length > 10) {
			this.szServicePortal = s;
		}

		this.openTab(this.szServicePortal);
	},
	
	onDslInfo : function()
	{
		this.openTab( this.szFBoxDSLInfo );
	},
	
	onUpdate : function()
	{
		var servicePortal = true;
	
		try
		{
			if( this.xpCom != null )//BUG TEST
			{
				this.xpCom.Detect(2);
				servicePortal = false; 
			}
			else
			{
				servicePortal = false;
				//this.m_bDebug = true;
				this.DoAddonUpdate(4);//manuelle Suche -> Meldung ausgeben
			}
	}
		catch (err) { this.alertDebug(err);}
			
		if( servicePortal )//kkr: kein Windows/Fehler bitte per Hand suchen
		{
			this.openTab( this.szServicePortal );
		}
	//alert( "Dectect(2) gab zurck: " + rc );
	},

	openLaufwerk : function(e) {
		if( this.xpCom ){
			var s = "open";
			var rc = this.xpCom.DoAction(0,e,s);
	
			if( rc == -1 )
			{
				var menuItem = document.getElementById("fb_add_on-toolbar-button-laufwerk");
				//alert(menuItem.id);
				menuItem.disabled = true;
			}
		}
		else
		{
			this.openTab( this.szFtpHome );
		}
	},
	//nur suchen, da die Suche etwas dauern kann
	onLaufwerkeSuchen : function()
	{
		//this.alertDebug( "onLaufwerkeSuchen()" );
		//bLaufwerkeSuchen = false;
		var rc = -1;
		
		if( this.xpCom )
		{
			if( this.xpCom.DoAction )
			{
				var s = "search";

				rc = this.xpCom.DoAction(0,-1,s);
				//etwas warten, um Suche auszuwerten		
				setTimeout( "FB_Addon.aktualisiereMenu()", 5000);
			}
		}
		else
		{	//kein XP-COM: nicht Windows oder anderer Fehler
			this.alertDebug("Die Funktion wird nur von XP-COM unterstuetzt.");
		}
			
		if( rc == -1 )
		{
			//var menuItem = document.getElementById("fb_add_on-toolbar-button-laufwerk");
			//alert(menuItem.id);
			//menuItem.disabled = true;
		}
	},

	connectLaufwerk : function(index) {
		with (this) {
			try {
				if (xpCom) {
					var s = "open";
					var id = 10 + index;

					var rc = xpCom.DoAction(0, id, s);
				}
				else {	//kein XP-COM: nicht Windows oder anderer Fehler
					alertDebug("Die Funktion wird nur von XP-COM unterstuetzt.");
				}
			} catch (err) { alertDebug(err); }
		}
	},

	aktualisiereMenu : function() {
		with (this) {
			//alertDebug( "aktualisiereMenu()" );
			var verbinden = ResourceBundle.getString("verbinden");

			var hideSeparator = true;

			var anzahl = 5;

			if (xpCom) {
				if (xpCom.Get) {
					anzahl = xpCom.Get("Anzahl_Laufwerke");
				}
			}

			for (var i = 1; i < anzahl; i++) {
				if (xpCom) {
					szLaufwerk[i] = xpCom.GetValue(0, i);
					szLaufwerkText[i] = xpCom.GetValue(1, i);
				}
				else {
					szLaufwerk[i] = "";
					szLaufwerkText[i] = "";
				}

				var menuLaufwerk = document.getElementById("fb_add_on-toolbar-button-laufwerk-laufwerk" + (i + 1));

				if (menuLaufwerk == null) return;//falls nicht da

				menuLaufwerk.label = szLaufwerkText[i] + " " + verbinden;
				menuLaufwerk.hidden = szLaufwerkText[i].length == 0;

				if (szLaufwerkText[i].length > 0) {
					hideSeparator = false;
				}
			}
			if (hideSeparator) {
				//alertDebug( "Die Funktion wird nicht unterstuetzt." );
				var separator = document.getElementById("fb_add_on-toolbar-laufwerk-seperator");
				separator.hidden = true;
			}
		}
	},

	onEinstellungen : function() {
		with (this) {
			var sIpOld = szFritzBoxUrl;
			if (xpCom != null) {
				sIpOld = xpCom.FritzBoxIp;
			}
			var oldMarkieren = bTelNoMarkieren;
			var text = ResourceBundle.getString("FunktionNichtOS");
			
			var params = { inn: { FunktionNichtOS: text }, out: null };
			window.openDialog("chrome://fb_add_on/content/Einstellungen2.xul", "", "chrome, dialog, toolbar, modal, centerscreen, resizable=false", params).focus();

			var sIpNeu = "";
			if (xpCom != null) {
				sIpNeu = xpCom.FritzBoxIp;
			}

			if (sIpOld != sIpNeu) {
				alertDebug("Neue FB-Addresse");
				if (xpCom != null) xpCom.Detect(-1);
			}

			bReadRegistry = false; //neu einlesen
			getWerte();
			//alert(szInstance + " Einstellungen: " + szNationalVorwahl );
		}
	},

	ladeRegistry : function() {
		with (this) {
			alertDebug("ladeRegistry()");
			if (xpCom) {
				bTelNoMarkieren = xpCom.Get("TelNoMarkieren");
				szNationalVorwahl = xpCom.GetValue(2, 2);
				bIpStatusBar = xpCom.Get("IpStatusBar");
				szFritzBoxUrl = xpCom.GetString("FritzBoxIp");
				szFritzRepeaterUrl = xpCom.GetString("FritzRepeaterIp");
				loadBoxInfoRepeater();//fr SID
				//alert("IpStatusBar " + bIpStatusBar);
			}
		}
	},

	speichereRegistry : function() {
		with (this) {
			setBool("TelNoMarkieren", bTelNoMarkieren ? true : false );
			setString("NationalVorwahl", szNationalVorwahl );
			set("IpStatusBar", bIpStatusBar);
		}
	},
	
	onAbout : function()
	{
		with(this){
			if( xpCom != null )
			{
				szAbout = xpCom.GetString("AboutText");
			}
			else
			{
				szAbout = getAboutText();
			}
			
			var params = {inn:{about:szAbout, description:"bar", enabled:true}, out:null};
			window.openDialog("chrome://fb_add_on/content/about.xul", "CallFBAbout", "chrome, centerscreen, dialog, modal, resizable=false", params).focus();
			//nach dem Aktualisieren
			onLaufwerkeSuchen();
		}
	},
	//
	alertDebug : function(s) {
		if (this.m_bDebug) {
			alert(s);
		}
	},
	openTab : function(aUrl) {
		this.getWerte();

		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browserInstance = wm.getMostRecentWindow("navigator:browser").getBrowser();

		if (browserInstance == 0) {
			this.alertDebug("Fallback open Tab");
			var browserEnumerator = wm.getEnumerator("navigator:browser");
			browserInstance = browserEnumerator.getNext().getBrowser();
		}

		// Create tab
		var newTab = browserInstance.addTab(aUrl);

		// Focus tab
		browserInstance.selectedTab = newTab;

		// Focus *this* browser in case another one is currently focused
		browserInstance.focus();
	},

	dial : function(nrTelno) {
		//alertDebug("FB_Addon.Dial " + nrTelno);
		if (this.xpCom != null) {
			this.xpCom.DoAction(2, 0, nrTelno);
		}
		else {
			var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
			var textAnrufen = FB_Addon.ResourceBundle.getString("promptAnrufen");
			textAnrufen = textAnrufen.replace( "NUMMER", nrTelno );
			var result = prompts.confirm(window, "FRITZ!Box AddOn (FF)", textAnrufen);
			//alert( result );
			
			if( result == true )
			{
				var kennwort = FB_Addon.getPasswort();
				fb_add_on_dial(nrTelno,kennwort,this.szBenutzerName);
			}
		}

		return true;
	},
	//
	getAboutText : function() {
		var szAbout = "";
		var szAbout2 = "";
		//FRITZ!Box
		var boxInfo = this.xmlBoxInfo;
		
		if( boxInfo.length > 0 )
		{
			var start = boxInfo.indexOf( "<j:Name>");
			var ende = boxInfo.indexOf( "</j:Name>");
			
			if( ende > 0 )
			{
				var produkt = boxInfo.substring( start + 8, ende );
				
				start = boxInfo.indexOf( "<j:Version>");
				ende = boxInfo.indexOf( "</j:Version>");
			
				var fw = boxInfo.substring( start + 11, ende );
				
				szAbout = this.ResourceBundle.getString("AboutText");
				szAbout = szAbout.replace( "FRITZBOX", produkt );
				szAbout = szAbout.replace( "FW_VERSION", fw );		
			}
			else {
				szAbout = this.ResourceBundle.getString("AboutNichtGefunden");
			}
		}
		else
		{
			var name = this.getConfigDefValue(this.htmlConfigDef,"ProduktName");
			var firmware = this.getConfigDefValue(this.htmlConfigDef,"FirmwareVersion");
					
			if( name.length > 0 && firmware.length > 0 ) {
				szAbout = this.ResourceBundle.getString("AboutText");
				szAbout = szAbout.replace( "FRITZBOX", name );
				szAbout = szAbout.replace( "FW_VERSION", firmware );
			}
			else {
				szAbout = this.ResourceBundle.getString("AboutNichtGefunden");
			}
		}
		//Repeater
		boxInfo = this.xmlBoxInfoRepeater;
		
		if( boxInfo.length > 0 )
		{
			var produkt = this.getProduktNameRepeater();
			var firmwware = this.getVersionInstalledRepeater();
			
			if( produkt.length > 0 ) {
				szAbout2 = this.ResourceBundle.getString("AboutText");
				szAbout2 = szAbout2.replace( "FRITZBOX", produkt );
				szAbout2 = szAbout2.replace( "FW_VERSION", firmwware );
				
				szAbout = szAbout + "\n" + szAbout2;
			}
		}
		
		return szAbout;
	},
	getFBoxName : function() {
		var produkt = "";

		var boxInfo = this.xmlBoxInfo;
		
		if( boxInfo.length > 0 )
		{
			var start = boxInfo.indexOf( "<j:Name>");
			var ende = boxInfo.indexOf( "</j:Name>");
			
			if( ende > 0 )
			{
				produkt = boxInfo.substring( start + 8, ende );
			}
		}
		
		return produkt;
	},
	getBoxInfo : function(s) {
		var wert = "";

		var boxInfo = this.xmlBoxInfo;
		
		if( boxInfo.length > 0 )
		{
			var start = boxInfo.indexOf( "<j:" + s);
			var ende = boxInfo.indexOf( "</j:" + s);
			
			if( ende > 0 )
			{
				wert = boxInfo.substring( start + s.length + 4, ende );
			}
		}
		
		return wert;
	},
	
	getFritzOS : function() {
		var s = this.getBoxInfo("Version");
		var start = s.indexOf(".");
		var os = s.substring( start + 1 );

		return os;
	},

	//mit '+'-Zeichen
	getTelNoClean : function(nr) {
		var nrClean = new String("");
		for (var i = 0; i < nr.length; i++) {
			var c = nr.charAt(i);
			if ("+0123456789".indexOf(c) >= 0) {
				nrClean += c;
			}
		}

		return nrClean;
	},

	getTelNoNationalVorwahl : function(nrClean) {
		//alertDebug("getTelNoNationalVorwahl " + nrClean);
		var nr = new String(nrClean);
		with (this) {
			for (var j = 0; j < szNationalVorwahl.length; j++) {
				if (nrClean.charAt(j) == szNationalVorwahl.charAt(j)) {
					if (j + 1 == szNationalVorwahl.length) {
						nr = szAmtVorwahl + nrClean.substring(szNationalVorwahl.length); //Amt
						//alert("Amt geholt: " + nr);
						if (nr.charAt(0) == nr.charAt(1)) {
							nr = nr.substring(1);
							//alert("Mirko-Special " + nr);
						}
					}
				}
				else { //Anruf ins Ausland
					if(nr.charAt(0) == '+') {
						nr = szVorwahlInternational + nr.substring(1);
						//alert("Joerg-Special " + nr);
					}
					break;
				}
			}
		}

		return nr;
	},

	processDomFrame : function(e) {
		//alert("processDomFrame");

		setTimeout(function() {
			try {
				FB_Addon_check4TelNo(e.target.ownerDocument.body);
			}
			catch (err) { };
		}
				, 5000);
	},
	
	//aus FRITZ!Box laden
	loadConfigDef : function(){
		var httpRequest = new XMLHttpRequest();
		var THIS = this;//Zugriff aus this Zeiger
		//lokale Callback-Function
		function onloadedConfigDef()
		{
			THIS.htmlConfigDef = httpRequest.responseText;
			httpRequest = null;
			
			if( THIS.xpCom == null )
			{
				//alert(THIS.getConfigDefValue(THIS.htmlConfigDef,"FirmwareVersion"));
				var s = THIS.getConfigDefValue(THIS.htmlConfigDef,"ServiceportalUrl");
				
				if( s.length > 10 )
				{
					THIS.setString("ServiceportalUrl",s);
					//alert("ServiceportalUrl "+s);
				}
			}
		}

		httpRequest.open("GET", this.szFritzBoxUrl + "/html/config.def", true);
		httpRequest.onload = onloadedConfigDef;
		httpRequest.send(null);
	},
	
	loadBoxInfo : function()
	{
		var httpRequest = new XMLHttpRequest();
		
		var THIS = this;//Zugriff auf this
		//lokale Callback-Function
		function onloadLocalCallback()
		{
			THIS.xmlBoxInfo = httpRequest.responseText;
		}
		var url = this.szFritzBoxUrl + "/jason_boxinfo.xml";
		
		if( url.indexOf("http://") < 0 ) {
			url = "http://" + url;
		}
		//this.alertDebug(url);
		httpRequest.open("GET", url, true);
		httpRequest.setRequestHeader('Cache-Control', 'no-cache');
		httpRequest.onload = onloadLocalCallback;
		httpRequest.send(null);
	},
	
	loadBoxInfoRepeater : function()
	{
		if( this.szFritzRepeaterUrl.length == 0 ) return;
		
		var httpRequest = new XMLHttpRequest();
		
		var THIS = this;//Zugriff aus this Zeiger
		//lokale Callback-Function
		function onloadLocalCallback()
		{
			THIS.xmlBoxInfoRepeater = httpRequest.responseText;
			//alert(httpRequest.responseText);
		}

		httpRequest.open("GET", "http://" + this.szFritzRepeaterUrl + "/jason_boxinfo.xml", true);
		httpRequest.onload = onloadLocalCallback;
		//httpRequestBoxInfo.onreadystatechange = onloadedBoxInfo;
		httpRequest.setRequestHeader('Cache-Control', 'no-cache');
		httpRequest.send(null);
	},
	
	loadConfigDefRepeater : function()
	{
		if( this.szFritzRepeaterUrl.length == 0 ) return;
		
		var THIS = this;//Zugriff aus this Zeiger

		var httpRequest = new XMLHttpRequest();
		
		//lokale Callback-Function
		function onloadedConfigDefRepeater()
		{
			THIS.htmlConfigDefRepeater = httpRequest.responseText;
			THIS.xmlReqBoxInfoRepeater = null;
			//alert("onloadedConfigDefRepeater FW-Repeater: \n" + THIS.getConfigDefValue(THIS.htmlConfigDefRepeater,"FirmwareVersion"));
		}

		httpRequest = new XMLHttpRequest();
		httpRequest.open("GET", this.szFritzRepeaterUrl + "/html/config.def", true);
		httpRequest.onload = onloadedConfigDefRepeater;
		//httpRequest.onreadystatechange = onloadedConfigDefRepeater;
		httpRequest.setRequestHeader('Cache-Control', 'no-cache');
		httpRequest.send(null);
	},
	
	//Wert in Config.def Text suchen
	getConfigDefValue : function(configDev,s)
	{
		//alert(this.htmlConfigDef);
		s = s + " '";
		var text = configDev;//.toString();
		if( typeof text == "undefined" ) return "";
		
		var pos = text.indexOf(s,0) + s.length;
		var end = text.indexOf("' ?>",pos);
			
			//alert( "Positionen" + pos + "/" + end );
		if( pos > end || end < 1 )
		{
				return "";
			}

		var out = text.substr( pos, end - pos );
		console.log(out);

		return out;
	},
	
	getProduktNameRepeater : function()
	{
		var versionInstalled = "";
		
		if( this.xmlBoxInfoRepeater.length > 20 )//seltsam
		{
			var start = this.xmlBoxInfoRepeater.indexOf("<j:Name>");
			var ende = this.xmlBoxInfoRepeater.indexOf("</j:Name>");
			
			if( (start!=-1) && (ende!=-1) )
			{
				versionInstalled = this.xmlBoxInfoRepeater.substring( start + 8, ende );
			}
		}
		
		if( versionInstalled.length == 0 )
		{
			versionInstalled = this.getConfigDefValue(this.htmlConfigDefRepeater,"ProduktName");
		}
		
		//alert( "GetVersionInstalledBox() " + versionInstalled );
				
		return versionInstalled;
	},
	
	getVersionInstalledRepeater : function()
	{
		var versionInstalled = "";
			
		if( this.xmlBoxInfoRepeater.length > 20 )//seltsam
		{
			var start = this.xmlBoxInfoRepeater.indexOf( "<j:Version>");
			var ende = this.xmlBoxInfoRepeater.indexOf( "</j:Version>");
			
			if( (start!=-1) && (ende!=-1) )
			{
				versionInstalled = this.xmlBoxInfoRepeater.substring( start + 11, ende );
			}
		}
		
		if( versionInstalled.length == 0 )
		{
			var servicePortal = this.getConfigDefValue(this.htmlConfigDefRepeater,"ServiceportalUrl");
			
			var start = servicePortal.indexOf( "version=");
			var ende = servicePortal.indexOf( "&subversion");

			if( (start!=-1) && (ende!=-1) )
			{
				versionInstalled = servicePortal.substring( start + 8, ende );
			}
		}
		
		return versionInstalled;
	},
	
	//Zahlen
	get : function (name) {
			var value = 0;
		if (this.xpCom) {
			if (this.xpCom.Get) {
				value = this.xpCom.Get(name);
			}
		}
		else {
			if (this.gPrefs.prefHasUserValue(name)) {
				try {
					value = this.gPrefs.getIntPref(name);
				}
				catch (e) {
					value = this.gPrefs.getBoolPref(name);
				}
				//this.alertDebug("get " + name + ": " + value);//too much
			}
		}

		return value;
	},
	//Zahlen
	set : function(name, value)
	{
		if (this.xpCom) {
			this.xpCom.Set(name, value);
		}
		else {
			try {
				this.gPrefs.setIntPref(name, value);
			}
			catch (e) {
				value = this.gPrefs.setBoolPref(name,value);
			}
		}
		this.alertDebug("set " + name + ": " + value);
	},
		//bei Bool-Werten ist Linux pingelig
	setBool : function(name, value)
	{
		this.alertDebug("setBool " + name + ": " + value);
		if (this.xpCom) {
			this.xpCom.Set(name, value);
		}
		else {
			this.gPrefs.setBoolPref(name,value);
		}
	},
	getString : function(name) {
		var value = "";
		if (this.xpCom) {
			value = this.xpCom.GetString(name);
		}
		else {
			if (this.gPrefs.prefHasUserValue(name)) {
				value = this.gPrefs.getCharPref(name);
			}
		}
		//this.alertDebug("getString " + name + ": " + value);//too much
		return value;
	},
	setString : function(name, value) {
		this.alertDebug("setString " + name + ": " + value);
		if (this.xpCom) {
			this.xpCom.SetString(name, value);
		}
		else {
			this.gPrefs.setCharPref(name, value);
		}
	},
	getNonce : function()
	{
		var random = Math.random().toString();
		random = random.substring(2, random.length - 2);
		
		return random;
	},
	findNonce : function(xmlDoc)
	{
		var nodeNonce = xmlDoc.getElementsByTagName("Nonce");
		if( nodeNonce == null ) return "";
		nodeNonce = nodeNonce[0];
		if( nodeNonce == null ) return "";
		nodeNonce = nodeNonce.childNodes[0];
		if( nodeNonce == null ) return "";
		return nodeNonce.nodeValue;
	},
	//vergleicht die Versionsangabe mit der Vorgabe (aus Text-Resource!!!)
	isNewerVersion : function(update)
	{
		//alert("isNewerVersion() " + this.szVersion + " Update: " + update );
		if( this.szVersion != null && update != null )
		{
			var len = this.szVersion.length;
			
			if( update.length > len )
				len = update.length;
			
			for(var n = 0; n < len; n++)
			{
				var i = this.szVersion[n];
				var u = update[n];

				if(i > u) return false;
				if(i < u) return true;
			}
		}
		
		if( update.length > this.szVersion.length ) return true;//gute Frage ".1" versus ".10"
		
		return false;
	},
//
	requestExternalIp : function() {
		var THIS = this;
		this.xmlRequest = new XMLHttpRequest();

		//lokale Callback-Function
		function onReadyExternalIp() {
			if (THIS.xmlRequest.readyState == 4) {
				var okStatus = false;
				//gibt es nicht auf Linux
				try { okStatus = THIS.xmlRequest.statusText == "OK" } catch(err){THIS.alertDebug(err);};
				
				if (THIS.xmlRequest.status == 200 || okStatus )
				{
					var s = THIS.xmlRequest.responseXML;
					THIS.ExternalIp = s.getElementsByTagName("NewExternalIPAddress")[0].textContent;
					//alert("onReadyExternalIp" + THIS.ExternalIp);
				}
			}
			//alert(this.htmlConfigDef);
		}

		try {
			var url = "http://fritz.box:49000/upnp/control/WANIPConn1";

			this.xmlRequest.open("POST", url, true);
			this.xmlRequest.onreadystatechange = onReadyExternalIp;
			this.xmlRequest.setRequestHeader("CONTENT-TYPE", "text/xml; charset=UTF-8");
			this.xmlRequest.setRequestHeader("SOAPACTION", "urn:schemas-upnp-org:service:WANIPConnection:1#GetExternalIPAddress");

			var xml =	"<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
						"<s:Envelope s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"" +
						"xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
						"<s:Body><u:GetExternalIPAddress xmlns:u=\"urn:schemas-upnp-org:service:WANIPConnection:1\"/></s:Body></s:Envelope>";

			this.xmlRequest.send(xml);
		}
		catch (e) {
			alert("requestExternalIp" + e.message);
		}
	},
	//aus Chrome
	DoAddonUpdate : function(modus)
	{
		try {
		//alert("DoAddonUpdate()");
		var html = "<?xml version=\"1.0\" encoding=\"utf-8\"?>";
		html = html + "<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">";
		html += "<S:Body>";
		html += "<SoftwareUpdateCheck xmlns=\"http://jason.avm.de/updatecheck/\">";
		html += "<RequestHeader>";
		html += "<Nonce>VALUE_NONCE</Nonce>";//Platzhalter fr den Nonce
		html += "<UserAgent>FRITZ!Box AddOn (FF)</UserAgent>";
		html += "<ManualRequest>VALUE_MANUELL</ManualRequest>";
		html += "</RequestHeader>";
		html += "<SoftwareInfo>";
		html += "<Name>FRITZ!Box Addon (FF)</Name>";
		html += "<Version>VALUE_VERSION</Version>";
		html += "<Lang>de</Lang>";
		html += "<OS>VALUE_OS</OS>";
		html += "<Serial>VALUE_ID</Serial>";
		html += "</SoftwareInfo>";
		html += "</SoftwareUpdateCheck>";
		html += "</S:Body>";
		html += "</S:Envelope>";
		
		this.NONCE = this.getNonce();
		//GUID neu hacken		
		if( this.Guid.length == 0 )
		{
			this.Guid = "GUID: " + this.getNonce();//Zufallswert erzeugen
			this.setString("GUID",this.Guid);
		}
		else this.alertDebug("Eingelesen: "+this.Guid);
		
		this.szVersion = this.ResourceBundle.getString("Version");
		
		html = html.replace( "VALUE_NONCE", this.NONCE );
		html = html.replace( "VALUE_VERSION", this.szVersion );
		html = html.replace( "VALUE_ID", this.Guid );
		html = html.replace( "VALUE_OS", "Windows XP");//this.OperatingSystem );
		var manuell = this.updateMode ? "automatisch" : "manuell";
		html = html.replace( "VALUE_MANUELL", manuell );
		//alert(html);
		this.xmlRequest = new XMLHttpRequest();
		
		this.xmlRequest.open("POST", this.UPDATE_SERVER, true);
		this.xmlRequest.setRequestHeader('Content-Type',  "text/xml");
		this.xmlRequest.setRequestHeader("MessageType", "CALL");
		//xmlRequest.onload = onLoadedJason;
		//lokales callback
		this.xmlRequest.onload = function()
		{
			try
			{
				//if (xmlRequest.readystate != 4) { return; }
				FB_Addon.alertDebug("xmlRequest.onload()\n\n" + FB_Addon.xmlRequest.responseText);
				var xmlJasonResponse = FB_Addon.xmlRequest.responseText;

				var parser = new DOMParser();
				var xmlDoc = parser.parseFromString(xmlJasonResponse,"text/xml");
				//
				var nonce = FB_Addon.findNonce(xmlDoc);
				
				if( FB_Addon.NONCE == nonce )
				{			
					//var elInfoUrl = xmlDoc.getElementsByTagName("InfoURL");
					var elDownload = xmlDoc.getElementsByTagName("DownloadURL")[0];
					var elVersion = xmlDoc.getElementsByTagName("Version")[0];

					var digest = xmlDoc.getElementsByTagName("DigestValue")[0].childNodes[0].nodeValue;
					var signature = xmlDoc.getElementsByTagName("SignatureValue")[0].childNodes[0].nodeValue;
					
					var signed = xmlDoc.getElementsByTagName("SignedInfo")[0];
					var signedXml = (new XMLSerializer()).serializeToString(signed);

					var sigNode = xmlDoc.getElementsByTagName("Signature")[0];
					sigNode.parentNode.removeChild(sigNode);

					var body = xmlDoc.firstChild.firstChild; 
					//alert( body.textContent );
					var hashedXml = (new XMLSerializer()).serializeToString(body);
					
					//s = PLUGIN.CheckDigest(hashedXml,digest);
					//alert( digest );
					//s = ADDON.Call("CheckDigest", hashedXml, digest );
					//alert(s);
							
					if( modus > 1 )
					{
						if( elDownload != null )
						{
							var newer = FB_Addon.isNewerVersion(elVersion.textContent);
							
							if( newer == true )
							{
								var textUpdate = FB_Addon.ResourceBundle.getString("NeuesUpdate");
								textUpdate = textUpdate.replace( "PRODUKT_NAME", "FRITZ!Box Addon (FF)" );
							
								if( confirm(textUpdate) )
								{
									FB_Addon.openTab(elDownload.textContent);
								}
							}
							else if( modus > 3 ) {
								var textKeinUpdate = FB_Addon.ResourceBundle.getString("KeinNeuesUpdate");
								textKeinUpdate = textKeinUpdate.replace( "PRODUKT_NAME", "FRITZ!Box Addon (FF)" );
								alert( textKeinUpdate );
								FB_Addon.StartBoxUpdate();
								return;
							}
						}
						else
						{
							//nicht setzen, da kein sinnvoller Wert da
							urlUpdate = elInfoUrl[0].childNodes[0].nodeValue;
							//alert("Info-Url: " + urlUpdate);
						}			
					}
				}
				else
				{
					urlUpdate = "-";
				}
			} catch(e) {
				if( modus > 3 ) {//Meldung bei Fehler
					var textKeinUpdate = FB_Addon.ResourceBundle.getString("KeinNeuesUpdate");
					textKeinUpdate = textKeinUpdate.replace( "PRODUKT_NAME", "FRITZ!Box Addon (FF)" );
					alert( textKeinUpdate );
				}

				FB_Addon.alertDebug("DoAddonUpdate:onload " + e.message);
				//danach Box-Update starten
				FB_Addon.StartBoxUpdate();
			}
		}
		
		FB_Addon.xmlRequest.send(html);
		}
		catch (e) {
			this.alertDebug("DoAddonUpdate: " + e.message);
		}		
	},
	
	StartBoxUpdate : function()
	{
		var THIS = FB_Addon;
		//alert("StartBoxUpdate()");
		THIS.xmlReqBoxInfo = new XMLHttpRequest();
		THIS.xmlReqBoxInfo.open("GET", THIS.szFritzBoxUrl + "/jason_boxinfo.xml", true);

		function onloadedBoxInfo()
		{
			if( THIS != null )
			{
				if( THIS.xmlReqBoxInfo.responseText.length > 0 )
				{
					//alert("onloadedBoxInfo \n" + xmlReqBoxInfo.responseText);
					THIS.DoBoxUpdate();
					THIS = null;//nur einmal
				}
			}
		}
		THIS.xmlReqBoxInfo.onreadystatechange = onloadedBoxInfo;
		THIS.xmlReqBoxInfo.send(null);
		//alert("StartBoxUpdate() 1");
	},
	
	DoBoxUpdate : function()
	{
		//alert("DoBoxUpdate()");
		var html = "<?xml version=\"1.0\" encoding=\"utf-8\"?>";
		html += "<soap:Envelope xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\" ";//Space !!!
		html += "xmlns:soap-enc=\"http://schemas.xmlsoap.org/soap/encoding/\" ";
		html += "xmlns:j=\"http://jason.avm.de/updatecheck/\" ";
		html += "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ";
		html += "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">";
		html += "<soap:Body>";
		html += "	<j:BoxFirmwareUpdateCheck>";
		html += "		<j:RequestHeader>";
		html += "			<j:Nonce>VALUE_NONCE</j:Nonce>";//Platzhalter fr den Nonce
		html += "			<j:UserAgent>FRITZ!Box AddOn (FF)</j:UserAgent>";//to do
		html += "			<j:ManualRequest>VALUE_MANUELL</j:ManualRequest>";
		html += "		</j:RequestHeader>";
		html += "		<j:BoxInfo>";
		html += "BOX_INFO";
		html += "		</j:BoxInfo>";
		html += "	</j:BoxFirmwareUpdateCheck>";
		html += "</soap:Body>";
		html += "</soap:Envelope>";
		
		this.NONCE_BOX = this.getNonce();
		
		html = html.replace( "VALUE_NONCE", this.NONCE_BOX );
		var manuell = this.updateMode ? "automatisch" : "manuell";
		html = html.replace( "VALUE_MANUELL", manuell );

		var boxInfo = this.xmlReqBoxInfo.responseText;
		//alert( typeof boxInfo );
		var start = boxInfo.indexOf( "<j:Name");
		var ende = boxInfo.indexOf( "</j:Country>");
		//Fehler zB Box nicht gefunden
		if( ( start == - 1 ) || ( ende == - 1 ) ) return; 
		var text = boxInfo.substring( start, ende + 12 );
		//alert( text );
		html = html.replace( "BOX_INFO", text );
		//alert( html );
		this.xmlRequestBox = new XMLHttpRequest();
		
		this.xmlRequestBox.open("POST", this.UPDATE_SERVER, true);
		this.xmlRequestBox.setRequestHeader('Content-Type', "text/xml");
		this.xmlRequestBox.setRequestHeader("MessageType", "CALL");
		this.xmlRequestBox.onload = this.onLoadedJasonBox;
		this.xmlRequestBox.send(html);

		//alert( "DoBoxUpdate() Sended: \n\n" + html );
	},

	onLoadedJasonBox : function()
	{
		var boxInfo = FB_Addon.xmlReqBoxInfo.responseText;
		var start = boxInfo.indexOf( "<j:Name>");
		var ende = boxInfo.indexOf( "</j:Name>");
		var produkt = "FRITZ!Box Firmware";//default

		if( ( start != - 1 ) || ( ende != - 1 ) ) 
		{
			produkt = boxInfo.substring( start + 8, ende );
		}
		
		try
		{
			//if (xmlRequestBox.readystate != 4) { return; }
			var xmlJasonResponse = FB_Addon.xmlRequestBox.responseText;
			//alert("onLoadedJasonBox()\n\n" + xmlJasonResponse);

			var parser = new DOMParser();
			var xmlDoc = parser.parseFromString(xmlJasonResponse,"text/xml");
			//
			var nonce = FB_Addon.findNonce(xmlDoc);

			if( FB_Addon.NONCE_BOX == nonce )
			{			
				//var elInfoUrl = xmlDoc.getElementsByTagName("InfoURL");
				var elDownload = xmlDoc.getElementsByTagName("DownloadURL")[0];
				var elVersion = xmlDoc.getElementsByTagName("Version")[0];
				
				var digest = xmlDoc.getElementsByTagName("DigestValue")[0].childNodes[0].nodeValue;
				var signature = xmlDoc.getElementsByTagName("SignatureValue")[0].childNodes[0].nodeValue;
				
				var signed = xmlDoc.getElementsByTagName("SignedInfo")[0];
				var signedXml = (new XMLSerializer()).serializeToString(signed);

				var sigNode = xmlDoc.getElementsByTagName("Signature")[0];
				sigNode.parentNode.removeChild(sigNode);

				var body = xmlDoc.firstChild.firstChild; 
				//alert( body.xmlContent );
				var hashedXml = (new XMLSerializer()).serializeToString(body);
				//alert( hashedXml );
						
				if( elDownload != null )
				{
					var newer = FB_Addon.isNewerVersion(elVersion.textContent);
					//alert( "Box-Update: " + elVersion.textContent );
					
					if( newer == true ) {
						var textUpdate = FB_Addon.ResourceBundle.getString("NeuesUpdate");
						textUpdate = textUpdate.replace( "PRODUKT_NAME", produkt );
						
						if( confirm(textUpdate) )
						{
							FB_Addon.openTab(elDownload.textContent);
						}
						else
						{
							//danach Repeater-Update starten
							FB_Addon.StartRepeaterUpdate();
						}

						return;
					}
				}
				else
				{
					//nicht setzen, da kein sinnvoller Wert da
					//urlUpdateBox = elInfoUrl[0].childNodes[0].nodeValue;
					//alert("Info-Url: " + urlUpdate);
				}
				//alert(s);
			}
			else
			{
				//alert(NONCE + " versus " + nonce );
				//urlUpdateBox = "-";
			}
		} catch(e){alert(e.message);}

		var textKeinUpdate = FB_Addon.ResourceBundle.getString("KeinNeuesUpdate");
		textKeinUpdate = textKeinUpdate.replace( "PRODUKT_NAME", produkt );
		alert( textKeinUpdate );
		
		//danach Repeater-Update starten
		FB_Addon.StartRepeaterUpdate();
	},
	
	StartRepeaterUpdate : function()
	{
		if( this.szFritzRepeaterUrl.length == 0 ) return;

		var THIS = FB_Addon;
		THIS.xmlReqBoxInfoRepeater = new XMLHttpRequest();
		
		var url = "";
		
		if( THIS.szFritzRepeaterUrl.indexOf("http://") < 0 ) {
			url = "http://";
		}
		
		url = url + THIS.szFritzRepeaterUrl + "/jason_boxinfo.xml"
		//alert("StartRepeaterUpdate() " + url);
		
		THIS.xmlReqBoxInfoRepeater.open("GET", url, true);

		function onloadedBoxInfo()
		{
			//erst jetzt geht es
			if( THIS != null )
			{
				if( THIS.xmlReqBoxInfoRepeater.responseText.length > 0 )
				{
					//alert("onloadedBoxInfo Repeater\n" + THIS.xmlReqBoxInfoRepeater.responseText);
					THIS.xmlBoxInfoRepeater = THIS.xmlReqBoxInfoRepeater.responseText;
				}

				THIS.DoRepeaterUpdate();
				THIS = null;//nur einmal
			}
		}
		THIS.xmlReqBoxInfoRepeater.onreadystatechange = onloadedBoxInfo;
		THIS.xmlReqBoxInfoRepeater.send(null);
		//alert("StartRepeaterUpdate() 1");
	},
	
	DoRepeaterUpdate : function()
	{
		//FB_Addon.alertDebug("DoRepeaterUpdate()");

		var html = "<?xml version=\"1.0\" encoding=\"utf-8\"?>";
		html += "<soap:Envelope xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\" ";//Space !!!
		html += "xmlns:soap-enc=\"http://schemas.xmlsoap.org/soap/encoding/\" ";
		html += "xmlns:j=\"http://jason.avm.de/updatecheck/\" ";
		html += "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" ";
		html += "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">";
		html += "<soap:Body>";
		html += "	<j:BoxFirmwareUpdateCheck>";
		html += "		<j:RequestHeader>";
		html += "			<j:Nonce>VALUE_NONCE</j:Nonce>";//Platzhalter fr den Nonce
		html += "			<j:UserAgent>FRITZ!Box AddOn (GC)</j:UserAgent>";//to do
		html += "			<j:ManualRequest>VALUE_MANUELL</j:ManualRequest>";
		html += "		</j:RequestHeader>";
		html += "		<j:BoxInfo>";
		html += "BOX_INFO";
		html += "		</j:BoxInfo>";
		html += "	</j:BoxFirmwareUpdateCheck>";
		html += "</soap:Body>";
		html += "</soap:Envelope>";
		
		FB_Addon.NONCE_REPEATER = FB_Addon.getNonce();
		
		html = html.replace( "VALUE_NONCE", FB_Addon.NONCE_REPEATER );
		var manuell = FB_Addon.updateMode ? "automatisch" : "manuell";
		html = html.replace( "VALUE_MANUELL", manuell );

		var boxInfo = FB_Addon.xmlBoxInfoRepeater;

		if( boxInfo.length == 0 )
		{
			alert( "Repeater-BoxInfo nicht vorhanden" );
			setTimeout("DoRepeaterUpdate()", 1 * 1000);
			return;
		}
		//alert( typeof boxInfo );
		//boxInfo.replace( " = \"http://jason.avm.de/updatecheck/\"", "" );
		var start = boxInfo.indexOf( "<j:Name");
		var ende = boxInfo.indexOf( "</j:Country>");
		var text = "";
		//Fehler zB Box nicht gefunden
		if( ( start == - 1 ) || ( ende == - 1 ) )
		{
			var version = FB_Addon.getVersionInstalledRepeater();
			var repeater = FB_Addon.getProduktNameRepeater();

			if( (version.length > 0) && (repeater == "FRITZ!WLAN Repeater N/G") )
			{
				text = FB_Addon.createBoxInfoRepeaterNG(version);
				//alert(text);
			}
		}
		else
		{
			text = boxInfo.substring( start, ende + 12 );
		}

		if( text.length == 0 )
		{
			//FB_Addon.alertDebug( "Keine BoxInfo" );
			setTimeout("DoRepeaterUpdate()", 1 * 1000);
			return;
		}

		html = html.replace( "BOX_INFO", text );
		//FB_Addon.alertDebug( "Box-Info:\n\n" + html );
		FB_Addon.httpReqBoxInfoRepeater = new XMLHttpRequest();

		FB_Addon.httpReqBoxInfoRepeater.open("POST", FB_Addon.UPDATE_SERVER, true);
		FB_Addon.httpReqBoxInfoRepeater.setRequestHeader('Content-Type', "text/xml");
		FB_Addon.httpReqBoxInfoRepeater.setRequestHeader("MessageType", "CALL");
		FB_Addon.httpReqBoxInfoRepeater.onload = FB_Addon.onLoadedJasonRepeater;
		FB_Addon.httpReqBoxInfoRepeater.send(html);

		//alert( "DoBoxUpdate() Sended: \n\n" + html );
	},

	onLoadedJasonRepeater : function()
	{
		var boxInfo = FB_Addon.httpReqBoxInfoRepeater.responseText;
		var start = boxInfo.indexOf( "<j:Name>");
		var ende = boxInfo.indexOf( "</j:Name>");
		var produkt = FB_Addon.getProduktNameRepeater();

		if( ( start != - 1 ) || ( ende != - 1 ) ) 
		{
			produkt = boxInfo.substring( start + 8, ende );
		}

		try
		{
			//if (xmlRequest.readystate != 4) { return; }
			//alert("onLoadedJasonRepeater()\n\n" + FB_Addon.httpReqBoxInfoRepeater.responseText);
			var xmlJasonResponse = FB_Addon.httpReqBoxInfoRepeater.responseText;

			var parser = new DOMParser();
			var xmlDoc = parser.parseFromString(xmlJasonResponse,"text/xml");

			var nonce = FB_Addon.findNonce(xmlDoc);

			if( FB_Addon.NONCE_REPEATER == nonce )
			{			
				//if( !checkDigestAndSignature(xmlJasonResponse,xmlDoc) )
				{
					//return;
				}
				
				var elDownload = xmlDoc.getElementsByTagName("DownloadURL")[0];
				var elVersion = xmlDoc.getElementsByTagName("Version")[0];
				//var elInfoUrl = xmlDoc.getElementsByTagName("InfoURL");
				
				//start
				var newer = FB_Addon.isNewerVersion(elVersion.textContent);
				//alert( "Box-Update: " + newer );
					
				if( newer == true ) {
					var textUpdate = FB_Addon.ResourceBundle.getString("NeuesUpdate");
					textUpdate = textUpdate.replace( "PRODUKT_NAME", produkt );
				
					if( confirm(textUpdate) )
					{
						FB_Addon.openTab(elDownload.textContent);
					}
					return;
				}
			}
			else
			{
				//alert(NONCE + " versus " + nonce );
			}
		} catch(e){alert("onLoadedJasonRepeater: " + e.message);}

		var textKeinUpdate = FB_Addon.ResourceBundle.getString("KeinNeuesUpdate");
		textKeinUpdate = textKeinUpdate.replace( "PRODUKT_NAME", produkt );
		alert( textKeinUpdate );
	},
	
	//ohne BoxInfo Tags
	createBoxInfoRepeaterNG : function(version)
	{
		var xml = "<j:Name>FRITZ!WLAN Repeater N/G</j:Name>";
		xml += "<j:HW>138</j:HW>";
		xml += "<j:Version>FW_VERSION</j:Version>";
		xml += "<j:Revision></j:Revision>";
		xml += "<j:Serial>ffffffffffff</j:Serial>";
		xml += "<j:OEM>avm</j:OEM>";
		xml += "<j:Lang>de</j:Lang>";
		xml += "<j:Annex>B</j:Annex>";
		xml += "<j:Lab></j:Lab>";
		xml += "<j:Country></j:Country>";
		xml += "<j:Flag>nomini</j:Flag>";

		xml = xml.replace( "FW_VERSION", version );

		return xml;
	},

	QueryInterface : function()
	{
		try 
		{
			return XPCOMUtils.generateQI([Components.interfaces.IFB_AddOn]);
		}
		catch(e) {}

		return null;
	}
}
