/********************************************************************************************
 * Projekt:		FRITZ!Box AddOn																*
 * Version:		1.06.02																		*
 * Plattform:	XP/Vista/Windows 7 sowie MacOS/Linux (ohne XP-COM)							*
 *																							*
 * Modul:		C-Type Modul fr Firefox Addon												*
 * Autor:		Karsten																		*
 * Dateiname:	ctype.js																	*
 *																							*
 * 23.06.2011	64-bit Behandlung															*
 * 19.01.2011	Schlsselwort winapi_abi und es funzt :-)))									*
********************************************************************************************/

var ADDON = null;

function ADDON_DLLPrototyp() { }
//Prototyp de Addon Instanz
ADDON_DLLPrototyp.prototype = 
{
	//m_bDebug	: true,
	m_bDebug	: false,
	lib			: null,
	OS			: navigator.userAgent,
	//Funktionspointer
	Detect		: null,
	Call		: null,
	Get			: null,
	Set			: null,
	DoAction	: null,
	SetString	: null,
	GetValue4	: null,//intern verwenden
	GetString4	: null,//intern verwenden

	init : function() {
		var n = 0;
		try {
			var winPath = "windows";
			
			if( (this.OS.indexOf("Win64") > 0) && (this.OS.indexOf("x64") > 0) )
			{
				winPath = "windows64";
				this.alertDebug("Windows 64-bit not fully supported. Get the latest nightly build.");
			}
			
			Components.utils.import("resource://gre/modules/ctypes.jsm");  
			//this.m_bDebug = true;
			//this.MsgBox("Hello Firefox 4");//kleine Testfunktion
			var path = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile).path; 
			var s = path + "\\extensions\\fb_add_on@avm.de\\components\\" + winPath + "\\FB_AddOn4.dll";
			//this.alertDebug("Profil-Pfad: " + s);
			this.lib = ctypes.open(s);
			//this.alertDebug("Lib open: " + this.lib);
			  
			/* Declare the signature of the function we are going to call */  
			this.Detect		= this.lib.declare("Detect4", ctypes.winapi_abi, ctypes.int32_t, ctypes.int32_t );n++;
			this.Call		= this.lib.declare("Call4", ctypes.winapi_abi, ctypes.int32_t, ctypes.jschar.ptr, ctypes.jschar.ptr, ctypes.jschar.ptr );n++;
			this.Get		= this.lib.declare("Get4", ctypes.winapi_abi, ctypes.int32_t, ctypes.jschar.ptr );n++;
			this.Set		= this.lib.declare("Set4", ctypes.winapi_abi, ctypes.int32_t, ctypes.jschar.ptr, ctypes.int32_t );n++;
			this.DoAction	= this.lib.declare("DoAction4", ctypes.winapi_abi, ctypes.int32_t, ctypes.int32_t, ctypes.int32_t, ctypes.jschar.ptr );n++;
			this.GetValue4	= this.lib.declare("GetValue4", ctypes.winapi_abi, ctypes.int32_t, ctypes.int32_t, ctypes.int32_t, ctypes.jschar.ptr, ctypes.int32_t );n++;
			this.SetString	= this.lib.declare("SetString4", ctypes.winapi_abi, ctypes.int32_t, ctypes.jschar.ptr, ctypes.jschar.ptr );n++;
			this.GetString4	= this.lib.declare("GetString4", ctypes.winapi_abi, ctypes.int32_t, ctypes.jschar.ptr, ctypes.jschar.ptr, ctypes.int32_t );n++;
			//this.alertDebug("C-Types Funktionen erfolgreich geladen");
			//alert("C-Types Funktionen erfolgreich geladen");
			//lib.close();  
			return true;
		} 
		catch(e) {
			this.alertDebug("C-Type Fehler in Schritt: " + n + "  " + e.message);
			return false;
		}
	},
	//Schnittstelle
	GetString : function(s) {
		try {
			var buffer = ctypes.ArrayType(ctypes.jschar);
			var arr = new buffer(200);
			for(var i = 0; i < 200; i++) arr[i] = '\0';
			
			var ret = this.GetString4(s, arr, 200 );
			
			var erg = "";
			for(var i = 0; i < 200; i++)
			{
				if( arr[i] == '\0' ) break;
				erg += arr[i];
			}
			
			return erg;
		} catch(e){this.alertDebug("ADDON GetString: "+ e.message);}
		
		return "";
	},
		//Schnittstelle
	GetValue : function(f,n) {
		try {
			var buffer = ctypes.ArrayType(ctypes.jschar);
			var arr = new buffer(200);
			for(var i = 0; i < 200; i++) arr[i] = '\0';
			
			var ret = this.GetValue4( f, n, arr, 200 );
			
			var erg = "";
			for(var i = 0; i < 200; i++)
			{
				if( arr[i] == '\0' ) break;
				erg += arr[i];
			}
			
			return erg;
		} catch(e){this.alertDebug("ADDON GetValue: "+ e.message);}
		
		return "";
	},
	alertDebug : function(s) {
		if( this.m_bDebug ) alert(s);
	},
	
	MsgBox : function(s) {
		try {
			alert("msg");
			var lib = ctypes.open("C:\\WINDOWS\\system32\\user32.dll");  
	  
			/* Declare the signature of the function we are going to call */  
			var msgBox = lib.declare("MessageBoxW",  
									 ctypes.winapi_abi,  
									 ctypes.int32_t,  
									 ctypes.int32_t,  
									 ctypes.jschar.ptr,  
									 ctypes.jschar.ptr,  
									 ctypes.int32_t);  
			var MB_OK = 3;  
			  
			var ret = msgBox(0, s, "FRITZ!Box Addon", MB_OK);  
			  
			lib.close();  
		} catch(e){this.alertDebug("Error in C-Types Testfunktion: " + e.message);}
	}
}
