/********************************************************************************************
 * Projekt:		FRITZ!Box AddOn																*
 * Version:		2.00.00																		*
 * Plattform:	XP/Vista/Windows 7/Windows 8 sowie MacOS/Linux (ohne XP-COM)				*
 *																							*
 * Modul:		Java-Script fr Firefox Addon												*
 * Autor:		Karsten																		*
 * Dateiname:	FB_AddOn_Main.js															*
 *																							*
 * 09.07.2013	Endcheck ob TelNo zu kurz und Klammercheck, Style nur wenn TelNo			*
 * 04.10.2012	Smart Home nicht as Rufnummer verlinken									*
 * 23.08.2012	Extrawurst fr Binde- und Gedankenstriche									*
 * 21.07.2011	"+" oder "00" verlngern die maximale Rufnummernlnge						*
 * 14.07.2010	"+" darf mit in gewhlter Rufnummer bleiben									*
 * 02.06.2010	Anpassung an neue FRITZ!Box WebGUI											*
 * 22.10.2009	Telefonnummernmarkierung weiterentwickelt									*
 * 02.07.2009	Umstellung auf Prototyp und this Code										*
 * 10.06.2009	Laufwerke suchen und Laufwerke-Men erweitern								*
 * 28.05.2009	Fallback/Workaround: ffnen des Ftp-Home falls XP-COM nicht existiert		*
 * 22.04.2009	Speicher und Aktualisieren sowie Umstellung auf namespace					*
********************************************************************************************/

//
var FB_Addon = new FB_AddonPrototyp();

var FB_Addon_Dial = function(e) {
	//if (FB_Addon.xpCom == null) return;
	if (e.button != 0) return;
	var attr = e.target.getAttribute("class");
	if (attr != "FB_Addon_TelNo") return;
	var nrTelno = e.target.getAttribute("TelNo").toString();
	var nr = FB_Addon.getSelectionTelNo();
	//alert("onclick Telno" + nrTelno);
	FB_Addon.dial( nrTelno );
}

var FB_Addon_DialContext = function(e) {
	var nrTelno = FB_Addon.getSelectionTelNo();
	FB_Addon.dial( nrTelno );
}
//
var FB_Addon_check4TelNo = function(node) {
	//alert("check4TelNo");
	if (node.nodeType == 3)
		return FB_Addon_markiereTelNoText(node);

	var child;
	var result = false;

	for (var i = 0; i < node.childNodes.length; i++) {
		child = node.childNodes[i];
		if (/^(SCRIPT|IMG|INPUT|SELECT|A|HTML|META)$/.test(child.tagName)) {
			continue;
		}
		if (child.tagName == 'SPAN' && child.getAttribute('class') == 'FB_Addon_TelNo') {
			continue;
		}

		if( FB_Addon_check4TelNo(node.childNodes[i]) ) {
			result = true;
		}
	}

	return result;
};
//zur berprfung der Ziffernfolgen
//var FB_Addon_RegExChar = /[a-z,A-Z,_,$,%,*,#]/;
var FB_AddonRegExDatum1 = /^[0-9][\.\/-][0-3]?[0-9][\.\/-]\d{2}/;
var FB_AddonRegExDatum2 = /^[0-3]?[0-9][\.\/-][0-3]?[0-9][\.\/-]\d{2}/;
var FB_AddonRegExDatum4 = /^[0-3]?[0-9][\s\.\/-][0-3]?[0-9][\s\.\/-]\d{4}/;//mit white space
var FB_Addon_MIN_NUM = 8;
var FB_Addon_MAX_NUM = 5/*Vorwahl*/+9/*Rufnummer*/;

var FB_Addon_markiereTelNoText = function(node) {
	/*ab hier nach Chrome*/
	if (node == null || node == undefined) return false;

	var s = new String(node.textContent); //Optimierung node.data
	var len = s.length;
	if (s == null || len < FB_Addon_MIN_NUM) return false;
	//alert(len+ ":" + s);
	
	/*ab hier nach Chrome*/
	var nr = new String();
	var start = 0;
	var ende = len;
	var numLen = 0; var c = 0; var i = 0;
	var bValid = false; var bDigit = false;

	for (var m = 0; m < len; m = i + 1) {//uere Schleife: gesamte Zeichenkette
		start = m;
		ende = len;
		numLen = 0;
		nr = "";

		for (i = m; i < len; i++) {//innere Schleife: was noch nicht verarbeitet ist
			c = s.charAt(i);
			//Showstopper
			if (".,=".indexOf(c) >= 0) {
				//alert("Showbreaker[" + nr + "]");
				ende = i;
				break;
			}
			bValid = false;
			bDigit = ("+0123456789".indexOf(c) >= 0);
			//Nummern oder gltige Zeichen
			if (bDigit || ("-./() ".indexOf(c) >= 0)) {
				if (numLen > 0 || !("./-) ".indexOf(c) >= 0)) {//kein Freizeichen als erstes
					//if (c != ' ') {//kein Freizeichen
					nr += c;
					//alert("nr=" + nr);
					numLen = numLen + 1;
					bValid = true;
				}
			} else {
				var code = s.charCodeAt(i);
				//Gedanken- und Bindestrich
				if( (code == 8210) || (code == 8211) || (code == 8212) ) {
					bValid = true;
				}
			}

			if (nr.length == 1) {
				start = i;
			}

			if (nr.length > 0) {
				if (!bValid) {
					ende = i;
					if (numLen > FB_Addon_MIN_NUM) {
						break;
					}
					else {//neue Suche, den Text weiter nach neuer TelNo durchsuchen
						nr = "";
						numLen = 0;
						start = i;
						ende = len;
					}
				}
			}
		}
		//alert("Start: " + start + " Ende: " + ende);
		//if( nr.length>0)alert("nr out=" + numLen + "min " + FB_Addon_MIN_NUM);
		if (numLen >= FB_Addon_MIN_NUM) {
			var nrClean = "";
			var nrTrennzeichen = ""; //alle Trennzeichen
			var lenNummer = 0;
			var cDavor = "";

			//alert( "Nr [" + nr + "]" );
			//nr = nr.trim(); //erst ab 3.5

			for (var n = 0; n < nr.length; n++) {
				var c = nr.charAt(n); //alert( "Process " + c + " at " + n );
				//am Ende auf jeden Fall eine Ziffer (Klammern vermeiden)
				if (n == nr.length - 1) {
					//alert( "Last " + c + " with " + nr );
					while (("+0123456789".indexOf(c) < 0)) {
						nr = nr.substring(0, nr.length - 1);
						nrTrennzeichen += c; //das gelscht werdende Trennzeichen speichern
						c = nr.charAt(n); //bergehen
						//alert( "Add " + c + "to TelNo " + nr );
						ende = ende - 1;
						if (nr.length < FB_Addon_MIN_NUM) break; //sicherheitshalber
					}
				}

				if ("() .-/".indexOf(c) < 0) {
					nrClean += c;
					lenNummer++; //alert( "Add Clean" + nrClean );
				}
				else {
					nrTrennzeichen += c;
					if (cDavor == c) {
						if (c != ' ') {
							lenNummer = 0;
							nrClean = "";
							break;
						}
					}
				}
				cDavor = c;
			}

			//alert("detecting clean[" + nrClean + "]");
			if ((lenNummer < FB_Addon_MIN_NUM) || (nrTrennzeichen.length == 0)) {
				continue;
			}

			if (nrTrennzeichen.length > lenNummer)
				continue;

			//alert("dectecting clean[" + nrClean + "]" + " nr = " + nr);
			//kein Smart-Home und erst mal nur die erkennen bei denen wir uns sicher sind
			if( (nr.indexOf("08761") == 0) || ("+(0".indexOf(nr.charAt(0)) < 0) ) {
				if (nr.length) //alert("returning[" + nr + "]");
				continue;
			} else {
				if (nr.charAt(0) == '(') {//Prfung ob geffnete Klammer auch geschlossen wird
					if (nr.charAt(1) == '0' || nr.charAt(1) == '+') {//ob es nach Klammer sinnvoll weitergeht
						var k = 0;
						for (; k < nr.length/* - 4*/; k++) {//
							if (nr.charAt(k) == ')')
								break;
						}
						if (k + 4 > nr.length) {
							//alert("() Problem:" + nr);
							if (nrClean.length == 8) {
								//alert("() Jahreszahl-Problem:" + nr);
								continue;
							}
						}
					} else {
						//alert("Abbruch nach Klammer" + nr);
						continue;
					}
				}
				if (nrClean.charAt(0) == '+') {
					nrClean = FB_Addon.getTelNoNationalVorwahl(nrClean);
				}
			}

			//alert("Trennzeichenprfung " + nr);
			if (nr.indexOf('(') >= 0) {
				if (nr.indexOf(')') < 0) {//alert("() Problem:" + nrTrennzeichen);
					continue;
				}
			}

			var bTrenner = false;
			//alert("existiert ein anderes Trennzeichen, aber BITTE NICHT am Schluss");
			for (var n = 0; n < nr.length - 1; n++) {
				if (" -/".indexOf(nr.charAt(n)) >= 0) {// zB 030/39976-0
					bTrenner = true;
					break;
				}
			}

			if (!bTrenner) { //alert("Ohne Trennzeichen[" + nr + "]");
				continue;
			}
			//alert("Mit Trennzeichen[" + nr + "]");
			//prfen auf Datum
			if (FB_AddonRegExDatum1.test(nr) || FB_AddonRegExDatum2.test(nr) || FB_AddonRegExDatum4.test(nr)) {
				//alert("Skip Datum " + nr );
				continue;
			}

			if ((nr.charAt(0) == '(') && ("+0123456789".indexOf(nr.charAt(1)) < 0)) {
				//alert("Not dectecting[" + nr + "]");
				continue;
			}
			//alert("dectecting[" + nr.length + "] diff" + (ende - start));

			//am Schluss keine Ziffer
			while ("0123456789".indexOf(nr.charAt(numLen - 1)) < 0) {
				//alert("while[" + nr + "]" + nr.charAt(numLen - 1));
				numLen = numLen - 1;
				ende = ende - 1;
				nr = nr.substring(0, numLen - 1);
			}
			//zu lange Rufnummer behandeln
			if (nrClean.length > FB_Addon_MAX_NUM) {
				var bIntVorwahl = false;
				if( nrClean.length < (FB_Addon_MAX_NUM + 3) ) {
					if( nrClean.charAt(0) == '+' )
					{
						bIntVorwahl = true;
						//alert( "TelNo: " + nrClean + " mit "+ nrClean.length +" ist OK: Fall #" );
					}
					else if( (nrClean.charAt(0) == '0') && (nrClean.charAt(1) == '0') )
					{
						bIntVorwahl = true;
						//alert( "TelNo: " + nrClean + " mit "+ nrClean.length +" ist OK: 00" );
					}
				}
				
				if( !bIntVorwahl )				
				{
					//alert( "TelNo: " + nrClean + " mit "+ nrClean.length +" ist laenger als " + FB_Addon_MAX_NUM );
					return false;
				}
			}
			else if (nrClean.length < FB_Addon_MIN_NUM) {
				alert("TelNo zu kurz: " + nrClean);
				return false;
			}
			//alert("dectecting[" + nr.length + "] diff" + (ende - start));
			//alert(s);
			//alert("Anfang: " + start + " Ende: " + ende + " aus [" + s + "]");
			//if (ende < start) return;//auf jeden Fall ein Fehler

			var sText = s.substring(start, ende); //den verlinkten Teil ausschneiden
			//bisherigen Text splitten
			var node_link = content.document.createTextNode(sText);
			var node_prev = content.document.createTextNode(s.substring(0, start)); //alert("->"+s.substring(0, start)+"<-");
			var node_after = content.document.createTextNode(s.substring(ende, len));
			
			var node_anchor = content.document.createElement("a");

			var style = "text-decoration: underline; color:#000000;" + "background-color:#ffff00;" + "-moz-border-radius:1px;";
			node_anchor.setAttribute("style", style);
			//node_anchor.setAttribute("title", ('FB_Addon link_title'));
			node_anchor.setAttribute("class", "FB_Addon_TelNo");
			node_anchor.addEventListener("click", FB_Addon_Dial, false); //das funzt
			node_anchor.setAttribute("TelNo", nrClean);
			node_anchor.setAttribute("href", "#");

			//alert("["+sText+"]");
			//node_link.setAttribute("TelNo", nr);
			node_anchor.appendChild(node_link);

			var parentNode = node.parentNode;
			parentNode.replaceChild(node_after, node);

			parentNode.insertBefore(node_anchor, node_after);
			parentNode.insertBefore(node_prev, node_anchor);

			//den neuen Knoten (mit dem restlichen Text verarbeiten
			if (node_after.data.length > 0) {
				FB_Addon_markiereTelNoText(node_after);
			}
			return true;
			//i += nr.length;
		}
	}

	return false;
};
//
var FB_Addon_processDom = function(e) {
	//alert("processDom");
	if (FB_Addon.bTelNoMarkieren) {
		setTimeout(function() {
			try {
				if( FB_Addon_check4TelNo(e.target.defaultView.document.body) ) {
					FB_Addon_addStyle(e.target.defaultView.document.body);
				}
				//alert(statusbar.tooltiptext);
			}
			catch (err) { };
		}
				, 500);
	}
	//else alert("kein bTelNoMarkieren");
}
//
var FB_Addon_processDomFrame = function(e)
{
	if (FB_Addon.bTelNoMarkieren) {
		//alert("onDOMFrameContentLoaded");
		setTimeout(function() {
			try {
				FB_Addon_check4TelNo(e.target.ownerDocument.body);
			}
			catch (err) { };
		}
				, 500);
	}
}

function FB_Addon_Update_Statusbar() {
    //alert("FB_Addon_Update_Statusbar()");
	var statusbar = document.getElementById('fb_addon_status_bar');

	if (statusbar != null) {
		if (FB_Addon.bIpStatusBar == statusbar.hidden) {//kkr
		    statusbar.hidden = !FB_Addon.bIpStatusBar;
		    statusbar.label = "";
		}

		if (FB_Addon.bIpStatusBar) {
			var ip = "";
			
			if( (FB_Addon.xpCom != null) && (FB_Addon.xpCom.GetValue != null) ){
				ip = FB_Addon.xpCom.GetValue(2, 1);
			}
			else {
				FB_Addon.requestExternalIp();
				ip = FB_Addon.ExternalIp;
			}
			//alert("FB_Addon_Update_Statusbar() :[" + ip + "]");
		    
		    if( ip.length > 0 )
		    {
			    statusbar.label = "IP: " + ip;
			    //statusbar.tooltiptext = "";
			}
		}
	}

	setTimeout("FB_Addon_Update_Statusbar()", 10 * 1000);
}
function FB_Addon_addStyle(body) {
	var doc = body.ownerDocument;
	var style = doc.createElement('style');
	var style_txt = "FB_Addon_TelNo{\nheight:15px !important;\n white-space: nowrap !important;\n background-color: #0ff0ff;}";
	var style_txt_node = doc.createTextNode(style_txt);
	style.appendChild(style_txt_node);
	body.appendChild(style);
	//alert("Style added");
}

function FB_Addon_popupShowing(event) {
	var show = document.getElementById("FB_AddonContextAnrufen");

	//if (FB_Addon.bTelNoMarkieren)
	{
		var szSelection = FB_Addon.getSelectionTelNo();

		if (szSelection.length > 2) {
			if (szSelection.length > 30) {
				szSelection = szSelection.subString(25) + "...";
			}
			show.label = FB_Addon.ResourceBundle.getString("ContextMenu_Anruf_zu") + szSelection + "\""; 
			//show.label = "Rufe \"" + szSelection + "\" an";
			show.hidden = false;
		}
		else {
			show.hidden = true;
		}
	}
}

//Init beim Laden dh starten des Firefoxes
//window.addEventListener('load', FB_AddOn_Init, false);

var FB_Addon_OnLoadPopup = function() {
	//alert("FB_Addon_OnLoadPopup");
	FB_Addon.szInstance = "FB_Addon_OnLoadPopup";
	var appcontent = window.document.getElementById('appcontent');
	appcontent.addEventListener('DOMContentLoaded', FB_Addon_processDom, false);
	appcontent.addEventListener('DOMFrameContentLoaded', FB_Addon_processDomFrame, false);

	var contextMenu = document.getElementById("contentAreaContextMenu");

	if (contextMenu != null) {
		//contextMenu.addEventListener("contextmenu", FB_Addon_popupShowing, false);
		contextMenu.addEventListener("popupshowing", FB_Addon_popupShowing, false);
	}
	setTimeout("FB_Addon_initPerTimeout()", 5000);
	//FB_Addon.initAddon();
}

function FB_Addon_initPerTimeout()
{
	//alert("FB_Addon_initPerTimeout");
	FB_Addon.initAddon();
}