/********************************************************************************************
* Projekt:		FRITZ!Box AddOn																*
* Version:		2.00.00																		*
* Plattform:	XP/Vista/Windows 7/Windows 8 sowie MacOS/Linux (ohne XP-COM)				*
*																							*
* Modul:		Java-Script zum Whlen von Telefonnummern									*
* Autor:		Karsten																		*
* Dateiname:	fb_add_on_dial.js															*
*																							*
* 05.09.2013	Login immer per Lua															*
* 15.04.2013	SID-Erstellung																*
* 31.10.2012	Benutzername fr Signle Sign On												*
* 14.07.2010	"+" darf mit in gewhlter Rufnummer bleiben									*
* 				Hinweis md5.js muss eingebunden sein										*
*********************************************************************************************/
var challenge = "";
var sessionId = "";
var HOME_SID = "http://fritz.box";
var KENNWORT = "";
var BENUTZER = "";
var CALLED_NUMBER = "";
var CALLED_NUMBER_CLEAN = "";
var USE_LUA = true;

function fb_add_on_dial(nummer,kennwort,benutzerName)
{
	HOME_SID = "http://fritz.box";//nur FRITZ!Box darf whlen
	CALLED_NUMBER = nummer;
	KENNWORT = kennwort;

	if( (typeof benutzerName === "undefined") || benutzerName == null || benutzerName.length == 0 )
	{
		getSessionId(cbChallenge);
	}
	else
	{
		USE_LUA = true;
		BENUTZER = benutzerName;
		//alert("lua start");
		getSessionIdLua(cbChallenge);
	}
}

function fb_add_on_sid(ip,benutzerName,kennwort)
{
	CALLED_NUMBER = "";
	HOME_SID = ip;
	BENUTZER = benutzerName;
	KENNWORT = kennwort;
	var sid = "";
	
	if( HOME_SID.indexOf("http://") == -1 )
	{	
		HOME_SID = "http://" + HOME_SID;
	}
	
	if( (typeof benutzerName === "undefined") || benutzerName == null || benutzerName.length == 0 )
	{
		BENUTZER = "";//
		USE_LUA = true;
		//sid = getSessionId(cbChallenge);
		sid = getSessionIdLua(cbChallenge);
	}
	else
	{
		USE_LUA = true;
		sid = getSessionIdLua(cbChallenge);
	}
	
	return sid;
}

//Callback-Funktion die nach anfordern der SID aufgerufen wird
function cbChallenge(req) {
	if (req.responseXML != null) {
		var xmlRoot = req.responseXML.documentElement;
		var node = xmlRoot.getElementsByTagName('Challenge');
		if (node == null) return "";
		challenge = node[0].firstChild.data; //getElementsByTagName('Challenge'[0]);

		//alert("cbChallenge->" + challenge + "<-Ende Use Lua: " + USE_LUA);
		var response = buildResponse(KENNWORT, challenge);

		if( USE_LUA == true )
		{
			return loginLua(response, cbLoginSid);
		}
		else
		{
			return login(response, cbLoginSid);
		}
	}
	else
	{
		//if( USE_LUA == true )
		{
			return getSessionIdLua(cbLoginSid);
		}
		//else
		{
			return getSessionId(cbLoginSid);
		}
	}
	return "";
}

//SID anfordern
function getSessionId(callback) {
	var xhr = new XMLHttpRequest(); // im IE < 7 muss man da ein ActiveXObject erzeugen, aber das brauchst du wohl nicht.
	//alert("getSessionId");
	if (!xhr) {
		return "";
	}
	
	var url = HOME_SID + "/cgi-bin/webcm"; //bzw. statt fritz.box die IP der Box
	var strGetData = encodeURIComponent("getpage") + "=" + encodeURIComponent("../html/login_sid.xml");
	url += "?" + strGetData;
	xhr.open("GET",url, false);
	xhr.send(null);

	return callback(xhr);
}

function getSessionIdLua(callback) {
	var xhr2 = new XMLHttpRequest(); // im IE < 7 muss man da ein ActiveXObject erzeugen, aber das brauchst du wohl nicht.

	if (!xhr2) {
		return false;
	}
	
	var url = HOME_SID + "/login_sid.lua?zone=box"; //bzw. statt fritz.box die IP der Box
	xhr2.open("GET",url, false);
	xhr2.send(null);
	
	return callback(xhr2);
}

//Login ausfhren, danach wird die callback Funktion ausgefhrt
function login(response, callback) {
	var xhr = new XMLHttpRequest(); 
	if (!xhr) {
		return "";
	}

	var url = HOME_SID + "/cgi-bin/webcm";
	var strPostData = encodeURIComponent("getpage") + "=" + encodeURIComponent("../html/login_sid.xml");
	strPostData += "&" + encodeURIComponent("login:command/response") + "=" + encodeURIComponent(response);
	//alert(strPostData);
	xhr.open("POST", url, false);
	//bei Post !!!
	xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	xhr.send(strPostData);

	return callback(xhr);
}

function loginLua(response, callback) {
	var xhr = new XMLHttpRequest();
	if (!xhr) {
		return "";
	}

	var url = HOME_SID + "/login_sid.lua?zone=box&username=" + BENUTZER + "&response=" + response;
	var strPostData = null;
	xhr.open("GET", url, false);
	xhr.send(null);

	return callback(xhr);
}
function cbLoginDial(resp) {	
	//alert("cbLogin()->" + resp.responseText + "<-");
	var xmlRoot = resp.responseXML.documentElement;
	var node = xmlRoot.getElementsByTagName('SID');
	if (node == null) return "";
	sessionId = node[0].firstChild.data;
	
	return sessionId;
}
function cbLoginSid(resp) {	
	//alert("cbLoginSid()->" + resp.responseXML.documentElement + "<-");
	var xmlRoot = resp.responseXML.documentElement;
	var node = xmlRoot.getElementsByTagName('SID');
	if (node == null) return "";
	sessionId = node[0].firstChild.data;
	//alert("sid=="+sessionId);
	if( CALLED_NUMBER.length > 0 )
	{
		dialWithSid(sessionId);
		return "";
	}

	return sessionId;
}
	
function dialWithSid(sessionId) {	
	//alert("SID->" + sessionId + "<-Ende");
	for( var n = 0; n < CALLED_NUMBER.length; n++ )
	{
	    var c = CALLED_NUMBER.charAt(n);
	    
	    if( "+0123456789".indexOf(c,0) >= 0 )
	    {
	        CALLED_NUMBER_CLEAN += c;
	    }
	}
	
	var response = dialNumber(CALLED_NUMBER_CLEAN, sessionId);
	//alert( "Calling: " + CALLED_NUMBER + "\nSID->"+ sessionId + "<-" );
}

// Wenn telcfg:settings/UseClickToDial == "1", dann ist die Whlhilfe benutzbar.
// Wenn du in telcfg:command/Dial die Nummer schreibst, und das per POST an die Box schickst, dann whlt die Box die Nummer.

function dialNumber(number, sessionId) {
	var xhr = new XMLHttpRequest(); // im IE < 7 muss man da ein ActiveXObject erzeugen, aber das brauchst du wohl nicht.
	if (!xhr) {
		return false;
	}

	var strPostData = encodeURIComponent("telcfg:command/Dial") + "=" + encodeURIComponent(number);
	strPostData += "&" + encodeURIComponent("sid") + "=" + encodeURIComponent(sessionId);
	var url = HOME_SID + "/cgi-bin/webcm"; //bzw. IP der Box
	
	xhr.open("POST", url, true);
	xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	xhr.send(strPostData);
	
	return true;
}

//Hilfsfunktion
function makeDots(str) {
	var newStr = "";
	for (var i = 0, len = str.length; i < len; i++) {
		if (str.charCodeAt(i) > 255) {
			newStr += ".";
		}
		else {
			newStr += str.charAt(i);
		}
	}
	return newStr;
}
//Hilfsfunktion
function buildResponse(pw, challenge) {
	var str = challenge + "-" + makeDots(pw);
	var response = challenge + "-" + hex_md5(str);
	return response;
}
